
#include "main.h"





void UnpackInit()
{
  InAddr=InBit=0;
  Suspended=false;
  UnpAllBuf=false;
  UnpSomeRead=false;
  InBuf=(char*)malloc(MAX_SIZE);
  Window=(char*)malloc(MAXWINSIZE);
  InitLL();
  UnpInitData(false);
  dbg("MAXWINMASK=%p\n",MAXWINMASK);
}


void DoUnpack(int Method,bool Solid)
{
  dbg("Method=%d\n",Method);
  switch(Method)
  {
#ifdef OTHER
    case 14: case 13: case 12: case 11: case 10://add
    case 15:
      Unpack15(Solid);
      break;
    case 20:
    case 26:
      Unpack20(Solid);
      break;
#endif
    case 29:
    case 36:
      Unpack29(Solid);
      break;
  }
}


 void InsertOldDist(int Distance)
{
  OldDist[3]=OldDist[2];
  OldDist[2]=OldDist[1];
  OldDist[1]=OldDist[0];
  OldDist[0]=Distance;
}


 void InsertLastMatch(int Length,int Distance)
{
  LastDist=Distance;
  LastLength=Length;
}


void CopyString(int Length,int Distance)
{

  UINT32 DestPtr=UnpPtr -Distance;

  if (DestPtr<MAXWINSIZE-260 && UnpPtr<MAXWINSIZE-260)
  {

    Window[UnpPtr++]=Window[DestPtr++];
    off++;
    while (--Length>0)
		{

      Window[UnpPtr++]=Window[DestPtr++];
  	  off++;
		}
  } 
  else if( off<MAXWINMASK||DL_FsSGetFileSize( temname, 0 )<off-Distance+Length)
  //if(UnpPtr>Distance)
  	{
      while (Length--)
			{
			Window[UnpPtr++]=Window[DestPtr++ & MAXWINMASK];
			UnpPtr&=MAXWINMASK;
			off++;
			}
    }else 
    {
    FILE_HANDLE_T ftem;
    int i;
    char *temr;
  	temr=(char*)malloc(Length+1);
  	ftem = DL_FsOpenFile(temname, FILE_READ_MODE, 0);
    DL_FsFSeekFile(ftem,off-Distance,0);
    DL_FsReadFile(temr,1,Length,ftem, &rd );
    DL_FsCloseFile(ftem);
    i=0;
    while (Length--)
		{
		Window[UnpPtr++]=temr[i++];
		UnpPtr&=MAXWINMASK;
		}
		off+=i;
		free(temr);
    
    }
}


int DecodeNumber(int pos)
{
  int Bits;
  int N;
  int BitField=getbits() & 0xfffe;
  if (BitField<LL[pos].DecodeLen[8])
    if (BitField<LL[pos].DecodeLen[4])
      if (BitField<LL[pos].DecodeLen[2])
        if (BitField<LL[pos].DecodeLen[1])
          Bits=1;
        else
          Bits=2;
      else
        if (BitField<LL[pos].DecodeLen[3])
          Bits=3;
        else
          Bits=4;
    else
      if (BitField<LL[pos].DecodeLen[6])
        if (BitField<LL[pos].DecodeLen[5])
          Bits=5;
        else
          Bits=6;
      else
        if (BitField<LL[pos].DecodeLen[7])
          Bits=7;
        else
          Bits=8;
  else
    if (BitField<LL[pos].DecodeLen[12])
      if (BitField<LL[pos].DecodeLen[10])
        if (BitField<LL[pos].DecodeLen[9])
          Bits=9;
        else
          Bits=10;
      else
        if (BitField<LL[pos].DecodeLen[11])
          Bits=11;
        else
          Bits=12;
    else
      if (BitField<LL[pos].DecodeLen[14])
        if (BitField<LL[pos].DecodeLen[13])
          Bits=13;
        else
          Bits=14;
      else
        Bits=15;

  addbits(Bits);
  N=LL[pos].DecodePos[Bits]+((BitField-LL[pos].DecodeLen[Bits-1])>>(16-Bits));
  if (N<0 || N>=LL[pos].MaxNum)
    N=0;
  return(DecodeN[LL[pos].DecodePtr+N]);
}


void Unpack29(bool Solid)
{
  int Bits;
  int Number;
  int Distance;
  int DistNumber;
  int I;
  int DistNum;
  int LengthNumber;
  int Length;
  int LowDist;
  dbg("Unpack29:enter\n",NULL);
  FileExtracted=true;

  if (!Suspended)
  {
    UnpInitData(Solid);
    if (!UnpReadBuf())
      return;
    if ((!Solid || !TablesRead) && !ReadTables())
      return;
  }
  dbg("Unpack29:UnpReadBuf\n",NULL);

  if (PPMError)
    return;

  while (true)
  {

    UnpPtr&=MAXWINMASK;

    if (InAddr>ReadBorder)
    {
      if (!UnpReadBuf())
		  {

        	break;
		  }
    }

    if (((WrPtr-UnpPtr) & MAXWINMASK)<260 && WrPtr!=UnpPtr)
    {
      dbg("Unpack29:UnpWriteBuf\n",NULL);

      UnpWriteBuf();
      if (WrittenFileSize>DestUnpSize)
        return;
      if (Suspended)
      {
        FileExtracted=false;
        return;
      }
    }

    if (UnpBlockType==BLOCK_PPM)
      return;//add

    Number=DecodeNumber(0);
    if (Number<256)
    {
      Window[UnpPtr++]=Number;
	  off++;
      continue;
    }

    if (Number>=271)
    {
      Length=(LDecode[Number-=271]&0xff)+3;


      if ((Bits=(LBits[Number]&0xff))>0)
      {
        Length+=getbits()>>(16-Bits);
        addbits(Bits);
      }

      DistNumber=DecodeNumber(1);
      Distance=DDecode[DistNumber]+1;


      if ((Bits=(DBits[DistNumber]&0xff))>0)
      {
        if (DistNumber>9)
        {
          if (Bits>4)
          {
            Distance+=((getbits()>>(20-Bits))<<4);
            addbits(Bits-4);
          }
          if (LowDistRepCount>0)
          {
            LowDistRepCount--;
            Distance+=PrevLowDist;
          }
          else
          {
            LowDist=DecodeNumber(4);
            if (LowDist==16)
            {
              LowDistRepCount=LOW_DIST_REP_COUNT-1;
              Distance+=PrevLowDist;
            }
            else
            {
              Distance+=LowDist;
              PrevLowDist=LowDist;
            }
          }
        }
        else
        {
          Distance+=getbits()>>(16-Bits);
          addbits(Bits);
        }
      }
	  //dbg("Distance=%d",Distance);
      if (Distance>=0x2000)
      {
        Length++;
		  if (Distance>=0x40000L)
          Length++;
      }

      InsertOldDist(Distance);
      InsertLastMatch(Length,Distance);
      CopyString(Length,Distance);
      continue;
    }
    if (Number==256)
    {
      if (!ReadEndOfBlock())
        break;
      continue;
    }
    if (Number==257)
    {

        break;

    }
    if (Number==258)
    {
      if (LastLength!=0)
        CopyString(LastLength,LastDist);
      continue;
    }
    if (Number<263)
    {
      DistNum=Number-259;
      Distance=OldDist[DistNum];
      for (I=DistNum;I>0;I--)
        OldDist[I]=OldDist[I-1];
      OldDist[0]=Distance;

      LengthNumber=DecodeNumber(2);
      Length=(LDecode[LengthNumber]&0xff)+2;
      if ((Bits=(LBits[LengthNumber]&0xff))>0)
      {
        Length+=getbits()>>(16-Bits);
        addbits(Bits);
      }
      InsertLastMatch(Length,Distance);
      CopyString(Length,Distance);
      continue;
    }
    if (Number<272)
    {
      Distance=(SDDecode[Number-=263]&0xff)+1;
      if ((Bits=(SDBits[Number]&0xff))>0)
      {
        Distance+=getbits()>>(16-Bits);
        addbits(Bits);
      }
      InsertOldDist(Distance);
      InsertLastMatch(2,Distance);
      CopyString(2,Distance);
      continue;
    }
  }
  UnpWriteBuf();
}


bool ReadEndOfBlock()
{
  int BitField=getbits();
  bool NewTable,NewFile=false;
  if (BitField & 0x8000)
  {
    NewTable=true;
    addbits(1);
  }
  else
  {
    NewFile=true;
    NewTable=(BitField & 0x4000);
    addbits(2);
  }
  TablesRead=!NewTable;
  return !(NewFile || NewTable && !ReadTables());
}

bool UnpReadBuf()
{
  int DataSize=ReadTop-InAddr;
  int ReadCode;

  if (DataSize<0)
    return(false);
  if (InAddr>MAX_SIZE/2)
  {
    if (DataSize>0)
      memmove(InBuf,(InBuf+InAddr),DataSize);

    InAddr=0;
    ReadTop=DataSize;
  }
  else
    DataSize=ReadTop;

  ReadCode=UnpRead(InBuf+DataSize,(MAX_SIZE-DataSize)&~0xf);
  if (ReadCode>0)
    ReadTop+=ReadCode;
  ReadBorder=ReadTop-30;

  return(ReadCode!=-1);
}


void UnpWriteBuf()
{
  int WrittenBorder=WrPtr;

  UnpWriteArea(WrittenBorder,UnpPtr);
  WrPtr=UnpPtr;
}

void UnpWriteArea(int StartPtr,int EndPtr)
{
	//dbg("UnpWriteArea:enter\n",NULL);
  if (EndPtr!=StartPtr)
    UnpSomeRead=true;
	if (EndPtr<StartPtr)
  {
    UnpWriteData(&Window[StartPtr],-StartPtr & MAXWINMASK);
    UnpWriteData(Window,EndPtr);
    UnpAllBuf=true;
  }
  else
    UnpWriteData(&Window[StartPtr],EndPtr-StartPtr);
}


void UnpWriteData(char *Data,int Size)
{
  int WriteSize;

  int LeftToWrite;
  //dbg("UnpWriteData:enter\n",NULL);
  if (WrittenFileSize>=DestUnpSize)
    return;
  WriteSize=Size;
  //dbg("Size=%d",Size);
  //dbg("DestUnpSize=%d,WrittenFileSize=%d,\n",DestUnpSize,WrittenFileSize);
  LeftToWrite=DestUnpSize-WrittenFileSize;
  if (WriteSize>LeftToWrite)
    WriteSize=LeftToWrite;
  UnpWrite(Data,WriteSize);
  WrittenFileSize+=Size;
}


bool ReadTables()
{
  int I;
  char BitLength[BC];
  char Table[HUFF_TABLE_SIZE];
  int BitField;
  int Number;
  const int TableSize=HUFF_TABLE_SIZE;
  if (InAddr>ReadTop-25)
    if (!UnpReadBuf())
      return(false);
  addbits((8-InBit)&7);
  BitField=getbits();
  if (BitField & 0x8000)
  {
    UnpBlockType=BLOCK_PPM;

    return false;
  }
  UnpBlockType=BLOCK_LZ;

  PrevLowDist=0;
  LowDistRepCount=0;

  if (!(BitField & 0x4000))
    memset(UnpOldTable,0,sizeof(UnpOldTable));
  addbits(2);

  for (I=0;I<BC;I++)
  {
    int Length=(getbits() >> 12);
    addbits(4);
    if (Length==15)
    {
      int ZeroCount=(getbits() >> 12);
      addbits(4);
      if (ZeroCount==0)
        BitLength[I]=15;
      else
      {
        ZeroCount+=2;
        while (ZeroCount-- > 0 && I<sizeof(BitLength)/sizeof(BitLength[0]))
          BitLength[I++]=0;
        I--;
      }
    }
    else
      BitLength[I]=Length;
  }
  MakeDecodeTables((char*)BitLength,3);


  for (I=0;I<TableSize;)
  {
    if (InAddr>ReadTop-5)
      if (!UnpReadBuf())
        return(false);

    Number=DecodeNumber(3);
    if (Number<16)
    {
      Table[I]=(Number+UnpOldTable[I]) & 0xf;
      I++;
    }
    else
      if (Number<18)
      {
        int N;
        if (Number==16)
        {
          N=(getbits() >> 13)+3;
          addbits(3);
        }
        else
        {
          N=(getbits() >> 9)+11;
          addbits(7);
        }
        while (N-- > 0 && I<TableSize)
        {
          Table[I]=Table[I-1];
          I++;
        }
      }
      else
      {
        int N;
        if (Number==18)
        {
          N=(getbits() >> 13)+3;
          addbits(3);
        }
        else
        {
          N=(getbits() >> 9)+11;
          addbits(7);
        }
        while (N-- > 0 && I<TableSize)
          Table[I++]=0;
      }
  }
  TablesRead=true;
  if (InAddr>ReadTop)
    return(false);
  MakeDecodeTables(&Table[0],0);
  MakeDecodeTables(&Table[NC],1);
  MakeDecodeTables(&Table[NC+DC],4);
  MakeDecodeTables(&Table[NC+DC+LDC],2);
  memcpy(UnpOldTable,Table,sizeof(UnpOldTable));
  return(true);
}


void UnpInitData(int Solid)
{
  if (!Solid)
  {
    TablesRead=false;
    memset(OldDist,0,sizeof(OldDist));
    OldDistPtr=0;
    LastDist=LastLength=0;
    memset(Window,0,MAXWINSIZE);
    memset(UnpOldTable,0,sizeof(UnpOldTable));
    UnpPtr=WrPtr=off=0;
    PPMEscChar=2;


  }
  InitBitInput();
  PPMError=false;
  WrittenFileSize=0;
  ReadTop=0;
  ReadBorder=0;
#ifdef OTHER
  UnpInitData20(Solid);
#endif

}

void MakeDecodeTables(char *LenTab,int pos)
{
  int LenCount[16],TmpPos[16],I,Size=LL[pos].DecodeCnt;
  long M,N;
  memset(LenCount,0,sizeof(LenCount));
  memset((DecodeN+LL[pos].DecodePtr),0,Size*sizeof(int));
  for (I=0;I<Size;I++)
    LenCount[LenTab[I] & 0xF]++;

  LenCount[0]=TmpPos[0]=0;
  LL[pos].DecodePos[0]=LL[pos].DecodeLen[0]=0;
  for (N=0,I=1;I<16;I++)
  {
    N=2*(N+LenCount[I]);
    M=N<<(15-I);
    if (M>0xFFFF)
      M=0xFFFF;
    LL[pos].DecodeLen[I]=(int)M;
    TmpPos[I]=LL[pos].DecodePos[I]=LL[pos].DecodePos[I-1]+LenCount[I-1];
  }

  for (I=0;I<Size;I++)
    if (LenTab[I]!=0)
      DecodeN[LL[pos].DecodePtr+(TmpPos[LenTab[I] & 0xF]++)]=I;
  LL[pos].MaxNum=Size;
}

#ifdef OTHER
#define STARTL1  2
static int DecL1[]={0x8000,0xa000,0xc000,0xd000,0xe000,0xea00,
                             0xee00,0xf000,0xf200,0xf200,0xffff};
static int PosL1[]={0,0,0,2,3,5,7,11,16,20,24,32,32};

#define STARTL2  3
static int DecL2[]={0xa000,0xc000,0xd000,0xe000,0xea00,0xee00,
                             0xf000,0xf200,0xf240,0xffff};
static int PosL2[]={0,0,0,0,5,7,9,13,18,22,26,34,36};

#define STARTHF0  4
static int DecHf0[]={0x8000,0xc000,0xe000,0xf200,0xf200,0xf200,
                              0xf200,0xf200,0xffff};
static int PosHf0[]={0,0,0,0,0,8,16,24,33,33,33,33,33};


#define STARTHF1  5
static int DecHf1[]={0x2000,0xc000,0xe000,0xf000,0xf200,0xf200,
                              0xf7e0,0xffff};
static int PosHf1[]={0,0,0,0,0,0,4,44,60,76,80,80,127};


#define STARTHF2  5
static int DecHf2[]={0x1000,0x2400,0x8000,0xc000,0xfa00,0xffff,
                              0xffff,0xffff};
static int PosHf2[]={0,0,0,0,0,0,2,7,53,117,233,0,0};


#define STARTHF3  6
static int DecHf3[]={0x800,0x2400,0xee00,0xfe80,0xffff,0xffff,
                              0xffff};
static int PosHf3[]={0,0,0,0,0,0,0,2,16,218,251,0,0};


#define STARTHF4  8
static int DecHf4[]={0xff00,0xffff,0xffff,0xffff,0xffff,0xffff};
static int PosHf4[]={0,0,0,0,0,0,0,0,0,255,0,0,0};


void Unpack15(bool Solid)
{
  if (Suspended)
    UnpPtr=WrPtr;
  else
  {
    UnpInitData(Solid);
    OldUnpInitData(Solid);
    UnpReadBuf();
    if (!Solid)
    {
      InitHuff();
      UnpPtr=0;
    }
    else
      UnpPtr=WrPtr;
    --DestUnpSize;
  }
  if (DestUnpSize>=0)
  {
    GetFlagsBuf();
    FlagsCnt=8;
  }

  while (DestUnpSize>=0)
  {
    UnpPtr&=MAXWINMASK;

    if (InAddr>ReadTop-30 && !UnpReadBuf())
      break;
    if (((WrPtr-UnpPtr) & MAXWINMASK)<270 && WrPtr!=UnpPtr)
    {
      OldUnpWriteBuf();
      if (Suspended)
        return;
    }
    if (StMode)
    {
      HuffDecode();
      continue;
    }

    if (--FlagsCnt < 0)
    {
      GetFlagsBuf();
      FlagsCnt=7;
    }

    if (FlagBuf & 0x80)
    {
      FlagBuf<<=1;
      if (Nlzb > Nhfb)
        LongLZ();
      else
        HuffDecode();
    }
    else
    {
      FlagBuf<<=1;
      if (--FlagsCnt < 0)
      {
        GetFlagsBuf();
        FlagsCnt=7;
      }
      if (FlagBuf & 0x80)
      {
        FlagBuf<<=1;
        if (Nlzb > Nhfb)
          HuffDecode();
        else
          LongLZ();
      }
      else
      {
        FlagBuf<<=1;
        ShortLZ();
      }
    }
  }
  OldUnpWriteBuf();
}


void OldUnpWriteBuf()
{
  if (UnpPtr!=WrPtr)
    UnpSomeRead=true;
  if (UnpPtr<WrPtr)
  {
    UnpWrite(&Window[WrPtr],-WrPtr & MAXWINMASK);
    UnpWrite(Window,UnpPtr);
    UnpAllBuf=true;
  }
  else
    UnpWrite(&Window[WrPtr],UnpPtr-WrPtr);
  WrPtr=UnpPtr;
}


void ShortLZ()
{
  static int ShortLen1[]={1,3,4,4,5,6,7,8,8,4,4,5,6,6,4,0};
  static int ShortXor1[]={0,0xa0,0xd0,0xe0,0xf0,0xf8,0xfc,0xfe,
                                   0xff,0xc0,0x80,0x90,0x98,0x9c,0xb0};
  static int ShortLen2[]={2,3,3,3,4,4,5,6,6,4,4,5,6,6,4,0};
  static int ShortXor2[]={0,0x40,0x60,0xa0,0xd0,0xe0,0xf0,0xf8,
                                   0xfc,0xc0,0x80,0x90,0x98,0x9c,0xb0};


  int Length,SaveLength;
  int LastDistance;
  int Distance;
  int DistancePlace;
  int BitField;
  NumHuf=0;
  BitField=getbits();

  if (LCount==2)
  {
    addbits(1);
    if (BitField >= 0x8000)
    {
      OldCopyString((int)LastDist,LastLength);
      return;
    }
    BitField <<= 1;
    LCount=0;
  }

  BitField>>=8;

  ShortLen1[1]=ShortLen2[3]=Buf60+3;

  if (AvrLn1<37)
  {
    for (Length=0;;Length++)
      if (((BitField^ShortXor1[Length]) & (~(0xff>>ShortLen1[Length])))==0)
        break;
    addbits(ShortLen1[Length]);
  }
  else
  {
    for (Length=0;;Length++)
      if (((BitField^ShortXor2[Length]) & (~(0xff>>ShortLen2[Length])))==0)
        break;
    addbits(ShortLen2[Length]);
  }

  if (Length >= 9)
  {
    if (Length == 9)
    {
      LCount++;
      OldCopyString((int)LastDist,LastLength);
      return;
    }
    if (Length == 14)
    {
      LCount=0;
      Length=DecodeNum(getbits(),STARTL2,DecL2,PosL2)+5;
      Distance=(getbits()>>1) | 0x8000;
      addbits(15);
      LastLength=Length;
      LastDist=Distance;
      OldCopyString(Distance,Length);
      return;
    }

    LCount=0;
    SaveLength=Length;
    Distance=OldDist[(OldDistPtr-(Length-9)) & 3];
    Length=DecodeNum(getbits(),STARTL1,DecL1,PosL1)+2;
    if (Length==0x101 && SaveLength==10)
    {
      Buf60 ^= 1;
      return;
    }
    if (Distance > 256)
      Length++;
    if (Distance >= MaxDist3)
      Length++;

    OldDist[OldDistPtr++]=Distance;
    OldDistPtr = OldDistPtr & 3;
    LastLength=Length;
    LastDist=Distance;
    OldCopyString(Distance,Length);
    return;
  }

  LCount=0;
  AvrLn1 += Length;
  AvrLn1 -= AvrLn1 >> 4;

  DistancePlace=DecodeNum(getbits(),STARTHF2,DecHf2,PosHf2) & 0xff;
  Distance=ChSetA[DistancePlace];
  if (--DistancePlace != -1)
  {
    PlaceA[Distance]--;
    LastDistance=ChSetA[DistancePlace];
    PlaceA[LastDistance]++;
    ChSetA[DistancePlace+1]=LastDistance;
    ChSetA[DistancePlace]=Distance;
  }
  Length+=2;
  OldDist[OldDistPtr++] = ++Distance;
  OldDistPtr = OldDistPtr & 3;
  LastLength=Length;
  LastDist=Distance;
  OldCopyString(Distance,Length);
}


void LongLZ()
{
  int Length;
  int Distance;
  int DistancePlace,NewDistancePlace;
  int OldAvr2,OldAvr3;
  int BitField;

  NumHuf=0;
  Nlzb+=16;
  if (Nlzb > 0xff)
  {
    Nlzb=0x90;
    Nhfb >>= 1;
  }
  OldAvr2=AvrLn2;

  BitField=getbits();
  if (AvrLn2 >= 122)
    Length=DecodeNum(BitField,STARTL2,DecL2,PosL2);
  else
    if (AvrLn2 >= 64)
      Length=DecodeNum(BitField,STARTL1,DecL1,PosL1);
    else
      if (BitField < 0x100)
      {
        Length=BitField;
        addbits(16);
      }
      else
      {
        for (Length=0;((BitField<<Length)&0x8000)==0;Length++)
          ;
        addbits(Length+1);
      }

  AvrLn2 += Length;
  AvrLn2 -= AvrLn2 >> 5;

  BitField=getbits();
  if (AvrPlcB > 0x28ff)
    DistancePlace=DecodeNum(BitField,STARTHF2,DecHf2,PosHf2);
  else
    if (AvrPlcB > 0x6ff)
      DistancePlace=DecodeNum(BitField,STARTHF1,DecHf1,PosHf1);
    else
      DistancePlace=DecodeNum(BitField,STARTHF0,DecHf0,PosHf0);

  AvrPlcB += DistancePlace;
  AvrPlcB -= AvrPlcB >> 8;
  while (1)
  {
    Distance = ChSetB[DistancePlace & 0xff];
    NewDistancePlace = NToPlB[Distance++ & 0xff]++;
    if (!(Distance & 0xff))
      CorrHuff(ChSetB,NToPlB);
    else
      break;
  }

  ChSetB[DistancePlace]=ChSetB[NewDistancePlace];
  ChSetB[NewDistancePlace]=Distance;

  Distance=((Distance & 0xff00) | (getbits() >> 8)) >> 1;
  addbits(7);

  OldAvr3=AvrLn3;
  if (Length!=1 && Length!=4)
  {
    if (Length==0 && Distance <= MaxDist3)
    {
      AvrLn3++;
      AvrLn3 -= AvrLn3 >> 8;
    }
    else if (AvrLn3 > 0)
    AvrLn3--;
  }
  Length+=3;
  if (Distance >= MaxDist3)
    Length++;
  if (Distance <= 256)
    Length+=8;
  if (OldAvr3 > 0xb0 || AvrPlc >= 0x2a00 && OldAvr2 < 0x40)
    MaxDist3=0x7f00;
  else
    MaxDist3=0x2001;
  OldDist[OldDistPtr++]=Distance;
  OldDistPtr = OldDistPtr & 3;
  LastLength=Length;
  LastDist=Distance;
  OldCopyString(Distance,Length);
}


void HuffDecode()
{
  int CurByte,NewBytePlace;
  int Length;
  int Distance;
  int BytePlace;

  int BitField=getbits();

  if (AvrPlc > 0x75ff)
    BytePlace=DecodeNum(BitField,STARTHF4,DecHf4,PosHf4);
  else
    if (AvrPlc > 0x5dff)
      BytePlace=DecodeNum(BitField,STARTHF3,DecHf3,PosHf3);
    else
      if (AvrPlc > 0x35ff)
        BytePlace=DecodeNum(BitField,STARTHF2,DecHf2,PosHf2);
      else
        if (AvrPlc > 0x0dff)
          BytePlace=DecodeNum(BitField,STARTHF1,DecHf1,PosHf1);
        else
          BytePlace=DecodeNum(BitField,STARTHF0,DecHf0,PosHf0);
  BytePlace&=0xff;
  if (StMode)
  {
    if (BytePlace==0 && BitField > 0xfff)
      BytePlace=0x100;
    if (--BytePlace==-1)
    {
      BitField=getbits();
      addbits(1);
      if (BitField & 0x8000)
      {
        NumHuf=StMode=0;
        return;
      }
      else
      {
        Length = (BitField & 0x4000) ? 4 : 3;
        addbits(1);
        Distance=DecodeNum(getbits(),STARTHF2,DecHf2,PosHf2);
        Distance = (Distance << 5) | (getbits() >> 11);
        addbits(5);
        OldCopyString(Distance,Length);
        return;
      }
    }
  }
  else
    if (NumHuf++ >= 16 && FlagsCnt==0)
      StMode=1;
  AvrPlc += BytePlace;
  AvrPlc -= AvrPlc >> 8;
  Nhfb+=16;
  if (Nhfb > 0xff)
  {
    Nhfb=0x90;
    Nlzb >>= 1;
  }

  Window[UnpPtr++]=(ChSet[BytePlace]>>8);
  off++;
  --DestUnpSize;

  while (1)
  {
    CurByte=ChSet[BytePlace];
    NewBytePlace=NToPl[CurByte++ & 0xff]++;
    if ((CurByte & 0xff) > 0xa1)
      CorrHuff(ChSet,NToPl);
    else
      break;
  }

  ChSet[BytePlace]=ChSet[NewBytePlace];
  ChSet[NewBytePlace]=CurByte;
}


void GetFlagsBuf()
{
  int Flags,NewFlagsPlace;
  int FlagsPlace=DecodeNum(getbits(),STARTHF2,DecHf2,PosHf2);

  while (1)
  {
    Flags=ChSetC[FlagsPlace];
    FlagBuf=Flags>>8;
    NewFlagsPlace=NToPlC[Flags++ & 0xff]++;
    if ((Flags & 0xff) != 0)
      break;
    CorrHuff(ChSetC,NToPlC);
  }

  ChSetC[FlagsPlace]=ChSetC[NewFlagsPlace];
  ChSetC[NewFlagsPlace]=Flags;
}


void OldUnpInitData(int Solid)
{
  if (!Solid)
  {
    AvrPlcB=AvrLn1=AvrLn2=AvrLn3=NumHuf=Buf60=0;
    AvrPlc=0x3500;
    MaxDist3=0x2001;
    Nhfb=Nlzb=0x80;
  }
  FlagsCnt=0;
  FlagBuf=0;
  StMode=0;
  LCount=0;
  ReadTop=0;
}


void InitHuff()
{
  int I;
  for (I=0;I<256;I++)
  {
    Place[I]=PlaceA[I]=PlaceB[I]=I;
    PlaceC[I]=(~I+1) & 0xff;
    ChSet[I]=ChSetB[I]=I<<8;
    ChSetA[I]=I;
    ChSetC[I]=((~I+1) & 0xff)<<8;
  }
  memset(NToPl,0,sizeof(NToPl));
  memset(NToPlB,0,sizeof(NToPlB));
  memset(NToPlC,0,sizeof(NToPlC));
  CorrHuff(ChSetB,NToPlB);
}


void CorrHuff(int *CharSet,int *NumToPlace)
{
  int I,J;
  for (I=7;I>=0;I--)
    for (J=0;J<32;J++,CharSet++)
      *CharSet=(*CharSet & ~0xff) | I;
  memset(NumToPlace,0,sizeof(NToPl));
  for (I=6;I>=0;I--)
    NumToPlace[I]=(7-I)*32;
}


void OldCopyString(int Distance,int Length)
{
  DestUnpSize-=Length;
  while (Length--)
  {
    Window[UnpPtr]=Window[(UnpPtr-Distance) & MAXWINMASK];
    UnpPtr=(UnpPtr+1) & MAXWINMASK;
	off++;
  }
 /* if( off<MAXWINMASK||DL_FsSGetFileSize( temname, 0 )<off-Distance+Length)
  //if(UnpPtr>Distance)
  	{
      while (Length--)
			{
			Window[UnpPtr++]=Window[DestPtr++ & MAXWINMASK];
			UnpPtr&=MAXWINMASK;
			off++;
			}
    }else 
    {
    FILE_HANDLE_T ftem;
    int i;
    char *temr;
  	temr=(char*)malloc(Length+1);
  	ftem = DL_FsOpenFile(temname, FILE_READ_MODE, 0);
    DL_FsFSeekFile(ftem,off-Distance,0);
    DL_FsReadFile(temr,1,Length,ftem, &rd );
    DL_FsCloseFile(ftem);
    i=0;
    while (Length--)
		{
		Window[UnpPtr++]=temr[i++];
		UnpPtr&=MAXWINMASK;
		}
		off+=i;
		free(temr);    
    }*/
}


int DecodeNum(int Num,int StartPos,
                               int *DecTab,int *PosTab)
{
  int I;
  for (Num&=0xfff0,I=0;DecTab[I]<=Num;I++)
    StartPos++;
  addbits(StartPos);
  return(((Num-(I ? DecTab[I-1]:0))>>(16-StartPos))+PosTab[StartPos]);
}





void CopyString20(int Length,int Distance)
{

  int DestPtr;
  LastDist=OldDist[OldDistPtr++ & 3]=Distance;
  LastLength=Length;
  DestUnpSize-=Length;

  DestPtr=UnpPtr-Distance;
  if (DestPtr<MAXWINSIZE-300 && UnpPtr<MAXWINSIZE-300)
  {
    Window[UnpPtr++]=Window[DestPtr++];
    Window[UnpPtr++]=Window[DestPtr++];
	off+=2;
    while (Length>2)
    {
      Length--;
      Window[UnpPtr++]=Window[DestPtr++];
	  off++;
    }
  }
  else
    while (Length--)
    {
      Window[UnpPtr]=Window[DestPtr++ & MAXWINMASK];
      UnpPtr=(UnpPtr+1) & MAXWINMASK;
	  off++;
    }
}


void Unpack20(bool Solid)
{
  int Bits;
  int Number;

  if (Suspended)
    UnpPtr=WrPtr;
  else
  {
    UnpInitData(Solid);
    if (!UnpReadBuf())
      return;
    if (!Solid)
      if (!ReadTables20())
        return;
    --DestUnpSize;
  }

  while (DestUnpSize>=0)
  {

    UnpPtr&=MAXWINMASK;


    if (InAddr>ReadTop-30)
      if (!UnpReadBuf())
        break;
    if (((WrPtr-UnpPtr) & MAXWINMASK)<270 && WrPtr!=UnpPtr)
    {
      OldUnpWriteBuf();
      if (Suspended)
        return;
    }
    if (UnpAudioBlock)
    {
      int AudioNumber=DecodeNumber(9+UnpCurChannel);

      if (AudioNumber==256)
      {
        if (!ReadTables20())
          break;
        continue;
      }
      Window[UnpPtr++]=DecodeAudio(AudioNumber);
	  off++;
      if (++UnpCurChannel==UnpChannels)
        UnpCurChannel=0;
      --DestUnpSize;
      continue;
    }

    Number=DecodeNumber(5);
    if (Number<256)
    {
      Window[UnpPtr++]=Number;
	  off++;
      --DestUnpSize;
      continue;
    }
    if (Number>269)
    {
      int DistNumber;
      int Distance;
      int Length=(LDecode[Number-=270]&0xff)+3;
      if ((Bits=(LBits[Number]&0xff))>0)
      {
        Length+=getbits()>>(16-Bits);
        addbits(Bits);
      }

      DistNumber=DecodeNumber(6);
      Distance=DDecode[DistNumber]+1;
      if ((Bits=(DBits[DistNumber]&0xff))>0)
      {
        Distance+=getbits()>>(16-Bits);
        addbits(Bits);
      }

      if (Distance>=0x2000)
      {
        Length++;
        if (Distance>=0x40000L)
          Length++;
      }

      CopyString20(Length,Distance);
      continue;
    }
    if (Number==269)
    {
      if (!ReadTables20())
        break;
      continue;
    }
    if (Number==256)
    {
      CopyString20(LastLength,LastDist);
      continue;
    }
    if (Number<261)
    {
      int Distance=OldDist[(OldDistPtr-(Number-256)) & 3];
      int LengthNumber=DecodeNumber(7);
      int Length=(LDecode[LengthNumber]&0xff)+2;
      if ((Bits=(LBits[LengthNumber]&0xff))>0)
      {
        Length+=getbits()>>(16-Bits);
        addbits(Bits);
      }
      if (Distance>=0x101)
      {
        Length++;
        if (Distance>=0x2000)
        {
          Length++;
          if (Distance>=0x40000)
            Length++;
        }
      }
      CopyString20(Length,Distance);
      continue;
    }
    if (Number<270)
    {
      int Distance=(SDDecode[Number-=261]&0xff)+1;
      if ((Bits=(SDBits[Number]&0xff))>0)
      {
        Distance+=getbits()>>(16-Bits);
        addbits(Bits);
      }
      CopyString20(2,Distance);
      continue;
   }
  }
  ReadLastTables();
  OldUnpWriteBuf();
}


bool ReadTables20()
{
  char BitLength[BC20];
  char Table[MC20*4];
  int TableSize,N,I;
  int BitField;
  int Number;
  if (InAddr>ReadTop-25)
    if (!UnpReadBuf())
      return(false);

  BitField=getbits();
  UnpAudioBlock=(BitField & 0x8000);

  if (!(BitField & 0x4000))
    memset(UnpOldTable20,0,sizeof(UnpOldTable20));
  addbits(2);

  if (UnpAudioBlock)
  {
    UnpChannels=((BitField>>12) & 3)+1;
    if (UnpCurChannel>=UnpChannels)
      UnpCurChannel=0;
    addbits(2);
    TableSize=MC20*UnpChannels;
  }
  else
    TableSize=NC20+DC20+RC20;

  for (I=0;I<BC20;I++)
  {
    BitLength[I]=(getbits() >> 12);
    addbits(4);
  }
  MakeDecodeTables(BitLength,8);
  I=0;
  while (I<TableSize)
  {
    if (InAddr>ReadTop-5)
      if (!UnpReadBuf())
        return(false);
    Number=DecodeNumber(8);
    if (Number<16)
    {
      Table[I]=(Number+UnpOldTable20[I]) & 0xf;
      I++;
    }
    else
      if (Number==16)
      {
        N=(getbits() >> 14)+3;
        addbits(2);
        while (N-- > 0 && I<TableSize)
        {
          Table[I]=Table[I-1];
          I++;
        }
      }
      else
      {
        if (Number==17)
        {
          N=(getbits() >> 13)+3;
          addbits(3);
        }
        else
        {
          N=(getbits() >> 9)+11;
          addbits(7);
        }
        while (N-- > 0 && I<TableSize)
          Table[I++]=0;
      }
  }
  if (InAddr>ReadTop)
    return(true);
  if (UnpAudioBlock)
    for (I=0;I<UnpChannels;I++)
      MakeDecodeTables(&Table[I*MC20],9+I);
  else
  {
    MakeDecodeTables(&Table[0],5);
    MakeDecodeTables(&Table[NC20],6);
    MakeDecodeTables(&Table[NC20+DC20],7);
  }
  memcpy(UnpOldTable20,Table,sizeof(UnpOldTable20));
  return(true);
}


void ReadLastTables()
{
  if (ReadTop>=InAddr+5)
  {
    if (UnpAudioBlock)
    {
      if (DecodeNumber(9+UnpCurChannel)==256)
        ReadTables20();
    }
    else if (DecodeNumber(5)==269)
        ReadTables20();
   }
}


void UnpInitData20(int Solid)
{
  if (!Solid)
  {
    UnpChannelDelta=UnpCurChannel=0;
    UnpChannels=1;
    memset(AudV,0,sizeof(AudV));
    memset(UnpOldTable20,0,sizeof(UnpOldTable20));
  }
}


char DecodeAudio(int Delta)
{

  int PCh;
  int Ch;
  int D;
  AudV[UnpCurChannel].ByteCount++;
  AudV[UnpCurChannel].D4=AudV[UnpCurChannel].D3;
  AudV[UnpCurChannel].D3=AudV[UnpCurChannel].D2;
  AudV[UnpCurChannel].D2=AudV[UnpCurChannel].LastDelta-AudV[UnpCurChannel].D1;
  AudV[UnpCurChannel].D1=AudV[UnpCurChannel].LastDelta;
  PCh=8*AudV[UnpCurChannel].LastChar+AudV[UnpCurChannel].K1*AudV[UnpCurChannel].D1+AudV[UnpCurChannel].K2*AudV[UnpCurChannel].D2+AudV[UnpCurChannel].K3*AudV[UnpCurChannel].D3+AudV[UnpCurChannel].K4*AudV[UnpCurChannel].D4+AudV[UnpCurChannel].K5*UnpChannelDelta;
  PCh=(PCh>>3) & 0xFF;

  Ch=PCh-Delta;

  D=((signed char)Delta)<<3;

  AudV[UnpCurChannel].Dif[0]+=abs(D);
  AudV[UnpCurChannel].Dif[1]+=abs(D-AudV[UnpCurChannel].D1);
  AudV[UnpCurChannel].Dif[2]+=abs(D+AudV[UnpCurChannel].D1);
  AudV[UnpCurChannel].Dif[3]+=abs(D-AudV[UnpCurChannel].D2);
  AudV[UnpCurChannel].Dif[4]+=abs(D+AudV[UnpCurChannel].D2);
  AudV[UnpCurChannel].Dif[5]+=abs(D-AudV[UnpCurChannel].D3);
  AudV[UnpCurChannel].Dif[6]+=abs(D+AudV[UnpCurChannel].D3);
  AudV[UnpCurChannel].Dif[7]+=abs(D-AudV[UnpCurChannel].D4);
  AudV[UnpCurChannel].Dif[8]+=abs(D+AudV[UnpCurChannel].D4);
  AudV[UnpCurChannel].Dif[9]+=abs(D-UnpChannelDelta);
  AudV[UnpCurChannel].Dif[10]+=abs(D+UnpChannelDelta);

  UnpChannelDelta=AudV[UnpCurChannel].LastDelta=(signed char)(Ch-AudV[UnpCurChannel].LastChar);
  AudV[UnpCurChannel].LastChar=Ch;

  if ((AudV[UnpCurChannel].ByteCount & 0x1F)==0)
  {
    int I;
    int MinDif=AudV[UnpCurChannel].Dif[0],NumMinDif=0;
    AudV[UnpCurChannel].Dif[0]=0;
    for (I=1;I<sizeof(AudV[UnpCurChannel].Dif)/sizeof(AudV[UnpCurChannel].Dif[0]);I++)
    {
      if (AudV[UnpCurChannel].Dif[I]<MinDif)
      {
        MinDif=AudV[UnpCurChannel].Dif[I];
        NumMinDif=I;
      }
      AudV[UnpCurChannel].Dif[I]=0;
    }
    switch(NumMinDif)
    {
      case 1:
        if (AudV[UnpCurChannel].K1>=-16)
          AudV[UnpCurChannel].K1--;
        break;
      case 2:
        if (AudV[UnpCurChannel].K1<16)
          AudV[UnpCurChannel].K1++;
        break;
      case 3:
        if (AudV[UnpCurChannel].K2>=-16)
          AudV[UnpCurChannel].K2--;
        break;
      case 4:
        if (AudV[UnpCurChannel].K2<16)
          AudV[UnpCurChannel].K2++;
        break;
      case 5:
        if (AudV[UnpCurChannel].K3>=-16)
          AudV[UnpCurChannel].K3--;
        break;
      case 6:
        if (AudV[UnpCurChannel].K3<16)
          AudV[UnpCurChannel].K3++;
        break;
      case 7:
        if (AudV[UnpCurChannel].K4>=-16)
          AudV[UnpCurChannel].K4--;
        break;
      case 8:
        if (AudV[UnpCurChannel].K4<16)
          AudV[UnpCurChannel].K4++;
        break;
      case 9:
        if (AudV[UnpCurChannel].K5>=-16)
          AudV[UnpCurChannel].K5--;
        break;
      case 10:
        if (AudV[UnpCurChannel].K5<16)
          AudV[UnpCurChannel].K5++;
        break;
    }
  }
  return(Ch);
}
#endif
int fread32(FILE_HANDLE_T fh, char *buf, int len)
{
int clen;
int total=0;
size_t rd;
while(len)
{
if (len>1024) clen=1024; else clen=len;
DL_FsReadFile(buf,1,clen, fh, &rd);
total+=rd;
if (rd!=clen) break;
buf+=rd;
len-=rd;
}
return(total);
}

int fwrite32(FILE_HANDLE_T fh, char *buf, int len)
{
int clen;
int total=0;
FILE_HANDLE_T temw;
  if(tembuff)
  {  
  temw = DL_FsOpenFile(temname, FILE_MODE_APPEND, 0);
  }

while(len)
{
if (len>1024) clen=1024; else clen=len;

if(tembuff)
DL_FsWriteFile(buf,1,clen,temw, &wr);

DL_FsWriteFile(buf,1,clen,fh, &wr);
total+=wr;
if (wr!=clen) break;
buf+=wr;
len-=clen;
}
DL_FsCloseFile(temw);
return(total);
}


int UnpRead(char *Addr,int Count)
{
  int i;
  i=fread32(fr,Addr,Count);
  if(i<0) return -1;
  return i;
}


void UnpWrite(char *Addr,int Count)
{
  fwrite32(fw,Addr,Count);
}






extern void kill_data(void *p, void (*func_p)(void *));

void ElfKiller(void)
{

  if(Window!=0) free(Window);
  if(InBuf!=0) free(InBuf);

}

UINT32 Register( char * file_uri, char * param, UINT32 reserve )
{
  int i,len;
  char* file=NULL;
  WCHAR uir[255];
  
    if (strlen(param)) 
    {
      char         buf[10];
	   
      FILE_HANDLE_T	fc;
      u_atou(file_uri, uir);
      uir[u_strlen(uir)-3] = 0;
      u_strcat(uir,L"cfg");   
      fc = DL_FsOpenFile(uir, FILE_READ_MODE, 0);
      if (fc == FILE_INVALID) goto end;
      rd = DL_FsGetFileSize(fc);
      cfgbuf = (WCHAR*)suAllocMem( rd+2, &err );
      if (err != 0) 
      {
      DL_FsCloseFile(fc);
      goto end;
      }
      DL_FsReadFile( cfgbuf, 1, rd, fc, &rd );
      if (cfgbuf[0] == 0xFEFF) {
        temname = cfgbuf+1;
      } else {
        temname = cfgbuf;
      }
      rd/=2;
      for (i=0; i < rd ; i++) {
        if (temname[i] == 0x0d) temname[i] = 0;
        if (temname[i] == 0x0a) {
           temname[i] = 0;
           map=temname+i+1;
           break;
        }
      
      }
      udbg("temname=%s",temname);
      udbg("mapid=%s",map);
      DL_FsCloseFile(fc);
      u_utoa(map, buf);
      mapid=strtoul(buf,NULL,16);  	
      param2uri(param,uir);
    }else
    goto end;

  udbg("file=%s",uir);
  file = (char *) suAllocMem( FILEURI_MAX_LEN+1, NULL );
  
  //u_strcpy(filename,L"/c/mobile/temp/1.rar");
  fr = DL_FsOpenFile(uir, FILE_READ_MODE, 0);
  if(fr==FILE_INVALID)
  goto end;
  

  DL_FsReadFile(file, 1, 7, fr, &rd);

  if(rd==7&& file[0]==0x52 && file[1]==0x61 && file[2]==0x72){
  
  NextPos=0x14;
  UnpackInit();
  *(u_strrchr(uir, '/')+1)=0;
do{
  DL_FsDeleteFile( temname, 0);
  if(fw!=FILE_INVALID)
    {
    DL_FsCloseFile(fw);
    fw=FILE_INVALID;
    }
    
  DL_FsFSeekFile(fr,NextPos,0);
  DL_FsReadFile(file,1,0x20,fr, &rd );
  if(rd!=0x20)
  break;
  
  HeadType=file[2]&0xff;
  Flags=(file[3]&0xff)+((file[4]&0xff)<<8);
  HeadSize=(file[5]&0xff)+((file[6]&0xff)<<8);
  UnpSize=(file[7]&0xff)+((file[8]&0xff)<<8)
    +((file[9]&0xff)<<16)+((file[10]&0xff)<<24);
  PackSize=(file[11]&0xff)+((file[12]&0xff)<<8)
    +((file[13]&0xff)<<16)+((file[14]&0xff)<<24);
  Version=file[24]&0xff;
  Method=file[25]&0xff;
  NameSize=(file[26]&0xff)+((file[27]&0xff)<<8);
  Attrib=file[28]&0xff;

  if(PackSize>MAXWINSIZE)
  tembuff=TRUE;
  dbg("HeadType=%d,Flags=%d,PackSize=%d,UnpSize=%d\n",HeadType,Flags,PackSize,UnpSize);
  

  u_utoa(uir,file);
  
    
  
    
  DL_FsReadFile(file, 1,NameSize, fr, &rd );
  u_strcpy(filename,uir);
  len=u_strlen(uir);
   
  file[NameSize]=0;
  dbg("file=%s",file);
  GBToUCS2(filename+len,file) ;
 // u_atou(file,filename);
    for(i=0;i<NameSize+len;i++)
    {
    if(filename[i]=='\\')
    {
    filename[i]=0;
    DL_FsMkDir(filename,0);
    filename[i]='/';
    }
    } 
  filename[i]=0;
  udbg("filename=%s",filename);
  if(Attrib & 0x10)
    {   
    
    //DL_FsMkDir(filename,0);
    
    NextPos+=HeadSize+UnpSize;
    
    }
  else{
     fw = DL_FsOpenFile(filename, FILE_MODE_WRITE, 0);
     if(fw==FILE_INVALID)
     	{
      NextPos+=HeadSize+UnpSize;
      continue;
      }  
    DL_FsFSeekFile(fr,NextPos+=HeadSize,0);    
    DestUnpSize=PackSize;
    NextPos+=UnpSize;
    
      if(PackSize!=UnpSize && PackSize>0)
       DoUnpack(Version,(Flags & 0x10)!=0);

      else
           {    while(PackSize>0)
               {
               i=((PackSize<1024)?PackSize:1024);
               
               PackSize-=i;        
               
               DL_FsReadFile(InBuf,1,i, fr, &rd);
               
               DL_FsWriteFile(InBuf,1,rd,fw, &wr);
               
               }
          }
  }
}while(1);
}
end:
if(file)
free(file);
UnpackLose();

LdrUnloadELF(&Lib);


 return 0;
}

void UnpackLose()
{

    if(fr!=FILE_INVALID)
    {
    DL_FsCloseFile(fr);
    fr=FILE_INVALID;
    }
    
    if(fw!=FILE_INVALID)
    {
    DL_FsCloseFile(fw);
    fw=FILE_INVALID;
    }
    
    if(InBuf)
    free(InBuf);
    if(Window)
    free(Window);
    if(cfgbuf)
    free(cfgbuf);

}
UINT32 util_asc2ul( const char * s, UINT32 count )
{
    char    b;
    UINT32    res = 0;
    
    while ( count > 0 ) {
        b = *s++;
        if ( b >= '0' && b <= '9' ) {
            b -= '0';
        } else if ( b >= 'A' && b <= 'F' ) {
            b = b - 'A' + 10;
        } else if ( b >= 'a' && b <= 'f' ) {
            b = b - 'a' + 10;
        } else
            b = 0;
        res = res << 4;
        res |= b;
        count--;
    }
    
    return res;
}
UINT32 param2uri(char *param,WCHAR *uri)
{
    _u64                    tmp;
    DL_FS_MID_T             fid;
	

    if (strlen(param) > 16) { //  ?
        u_atou(param, uri);
    } else { // id
        tmp.R0 = util_asc2ul(param+0, 8);
        tmp.R1 = util_asc2ul(param+8, 8);
    
        if (tmp.R0==0 && tmp.R1==0) {
            u_atou(param, uri);
        } else {
            memcpy(&fid, &tmp, sizeof(UINT64));
            DL_FsGetURIFromID( &fid, uri );
        }
    }
    return RESULT_OK;
}
UINT16 GBToUCS2( WCHAR* u_buf,char* g_buf)
{
	UINT16 i=0;
	UINT16 k=0;
	//UINT32 mapid=0x10d0b300;  	
	UINT16 tmp=0;    
	UINT8  temp[2];
  UINT32 len;


  len=strlen(g_buf);
	while (i <= len)
	{

		if (g_buf[i]<0x81)


		{
			if (g_buf[i]<0x20 )
			{
				i++;
				continue;
			}
			else
			{
				u_buf[k++] = g_buf[i++];
			}
               if (i == strlen(g_buf))u_buf[k++] = 0;
		}
		else 
		{    

			tmp = g_buf[i] - 0x81;
			tmp = tmp * 0xBF + g_buf[i+1] - 0x40;
			tmp = tmp << 1;

      //if (i == strlen(g_buf)) u_buf[k++] = 0;

			if (tmp < 0xBC04)

			{	



				temp[0] = *(UINT8*)(mapid+tmp);
				temp[1] = *(UINT8*)(mapid+tmp+1);

				u_buf[k++] = (temp[1] << 8) | temp[0];
				i += 2;
			}
			else
	                {
				i++;
				continue;
			}
		}
	
	}
 u_buf[k] = 0;



	return k;
}

